import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Vector;

public class FileReference {
	Peer peer;
	
	String filetype, filename, timestamp;
	int owner, counter=0;
	Vector<Integer> hosts;
	
	FileReference(Peer peer, String filetype, String filename, int host){
		this.peer = peer;
		setTimeStamp();
		Boolean b = false;
		hosts = new Vector<Integer>();
		
		for (int i=0; i<peer.filereferences.size(); i++){
			FileReference ref = peer.filereferences.get(i);
			
			if (ref.filename.equals(filename)){
				if (!ref.hosts.contains(new Integer(host))){
					ref.hosts.add(host);
				}
				b = true;
			}
		}
		if (!b){
			hosts.add(host);
			this.filetype = filetype; this.filename = filename; this.owner = host;
			peer.filereferences.add(this);
		}
	}
	
	FileReference(Peer peer, String filetype, String filename, String host){
		this(peer, filetype, filename, Integer.parseInt(host));
	}
		
	public String toString(){
		String hostlist = "";
		
		for (int i=0; i<hosts.size(); i++){
				hostlist+=hosts.get(i);
				if (i < hosts.size()-1)
					hostlist+=", ";
		}
		return "{" + hostlist + "}->" + filename + ", owner="+ owner + ", counter="+counter;
	}
	
	public void setTimeStamp(){
		SimpleDateFormat form = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
		Calendar now = Calendar.getInstance();
		timestamp = form.format(now.getTime());
	}
}
