import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;

public class FileServer extends Thread{
	Peer peer;
	int port;
	String mode, filename;
	FileServer(Peer peer, int port, String mode, String filename){
		super("File Server");
		this.peer = peer;
		this.port = port;
		this.mode = mode;
		this.filename = filename;
		start();
	}
	
	public void run(){
		try{
			ServerSocket s = new ServerSocket(port);
			Socket filesock = s.accept(); //Listen for client

		if (mode.equals("receive")){
			
			int filesize=6022386, bytesRead, current = 0;
			
			byte [] mybytearray  = new byte [filesize];
			InputStream is = filesock.getInputStream();

			FileOutputStream fos = new FileOutputStream(peer.path + "/" + filename);
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			bytesRead = is.read(mybytearray,0,mybytearray.length);
			current = bytesRead;
			
		    do {
		       bytesRead = is.read(mybytearray, current, (mybytearray.length-current));
		       if (bytesRead >= 0) current += bytesRead;
			} while(bytesRead > -1);
		    
			bos.write(mybytearray, 0, current);
			bos.flush();
			File f = new File(peer.path + "/" + filename);
			if (f.exists()){
				peer.publishedfiles.add(filename);
				//peer.requestprocessor.exec("cache " + filename + " from " + peer.id);
				peer.requestprocessor.exec("File: '"+f.getName()+"' Received, Size=" + f.length() + " bytes");
			}
			bos.close();
			filesock.close();
		}
		
		if (mode.equals("send")){
			File f = new File(filename);
			byte [] mybytearray  = new byte [(int)f.length()];
			FileInputStream fis = new FileInputStream(f);
			BufferedInputStream bis = new BufferedInputStream(fis);
			bis.read(mybytearray,0,mybytearray.length);
			OutputStream os = filesock.getOutputStream();
			
			os.write(mybytearray,0,mybytearray.length);
			os.flush();
			filesock.close();
			System.out.println("File: '"+f.getName()+"' Sent, Size=" + f.length() + " bytes");
		}
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
}
