import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.text.SimpleDateFormat;
import java.util.Calendar;

public class Logger {
	Peer peer;
	File log;
	Writer output;
	SimpleDateFormat time = new SimpleDateFormat("h:mm:ss a");
    Calendar cal;
    String row = "";
    int i=0;
    
	Logger(Peer peer){
		try{
			this.peer = peer;
			log = new File("Peer-" + peer.id + "-log.html");

			output = new BufferedWriter(new FileWriter(log));
			output.write("<html><head><link rel='stylesheet' type='text/css' href='stylesheet.css' /><title>Peer "+ peer.id + " Log</title></head><body><p class='title'>Peer " + peer.id + " Log</p><table><th>#</th><th>Time</th><th>Event</th><th>Thread/Object</th><th>Prev->Peer->Next</th><th>Hosted files</th><th>Brokered filetypes</th><th>File references</th><th>Subscribers</th>");
			output.flush();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	synchronized void println(Object thread, String event) throws IOException{
		log(thread, event);
		System.out.println(event);
	}

	synchronized void log(Object thread, String event) throws IOException{
		output = new BufferedWriter(new FileWriter(log, true));
		if (row.equals("")){
			row = "class='a'";
		}
		else
			 row = "";
		output.write("<tr " + row + " ><td>"+ (i++) +"<td width='5%'>" + time.format(Calendar.getInstance().getTime()) + "</td><td width='40%'>" + event + "</td><td width='15%'>" + thread + "</td><td>" + peer.prev + "->" + peer.id + "->" + peer.next + "</td><td>" + peer.list(peer.publishedfiles) + "</td><td>" + peer.list(peer.managedfiletypes) + "</td><td> " + peer.list(peer.filereferences) + "</td><td> " + peer.list(peer.subscriptions) + "</td></tr></font>");
		output.close();
	}
}
