//Jesse Campbell
//Dec. 9, 2010
//NJIT - CS656 Section 101 - Project Phase 3
//Instructor: Cristian Borcea
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.Writer;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Enumeration;
import java.util.Vector;

public class Peer{
	public static void main(String[] args){
		if (args.length == 1)
			new Peer(Integer.parseInt(args[0]));
		else
			new Peer(65535);
	}
	
	int port, prev, id, next;
	Vector <Integer> managedfiletypes;
	Vector <FileReference> filereferences;
	Vector <String> publishedfiles;
	Vector <Subscriber> subscriptions;
	Server server;
	LocalClient localclient;
	RequestProcessor requestprocessor;
	Logger logger;
	String path;
	File folder;
	
	Peer(int port){
		try{
		id = setid();
		path = "Peer " + id + " Files";
		folder = (File)new File(path);
		folder.mkdir();
		cleardirectory();
		this.port = port;
		managedfiletypes = new Vector <Integer> ();
		filereferences = new Vector <FileReference> ();
		publishedfiles = new Vector <String> ();
		subscriptions = new Vector <Subscriber> ();
		logger = new Logger(this);
		logger.log(this, "Started");
		server = new Server(this);
		localclient = new LocalClient(this);
		requestprocessor = new RequestProcessor(this);
	
		if (id == 1){
			generatefiles();
		}
		join();
		makesubstxt();
		loadsubscriptions();
		showstate();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public String lastupdate(){
		try{
			BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File(path + "/" + "subscriptions.txt")))));
			String strLine;
		
			while ((strLine = br.readLine()) != null){
				String words[] = strLine.split(" ");
				return words[0] + " " + words[1];
			}
		}
		catch (Exception e){
			e.printStackTrace();
		}
		return null;
	}
	
	public void updatetimestamp(String timestamp){
		try{
			BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File(path + "/" + "subscriptions.txt")))));
			
			String strLine;
			String result = timestamp;
			
			while ((strLine = br.readLine()) != null){
				String words[] = strLine.split(" ");
				
				for (int i=2; i<words.length; i++)
					result += words[i] + " ";

				Writer output = new BufferedWriter(new FileWriter(new File(path + "/" + "subscriptions.txt")));
				output.write(result);
				output.close();
			}
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
	
	public void updatetimestamp(){
		try{
			BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File(path + "/" + "subscriptions.txt")))));
			
			String strLine;
			String result = "";
			
			while ((strLine = br.readLine()) != null){
				String words[] = strLine.split(" ");
				result = now() + " ";
				
				for (int i=2; i<words.length; i++)
					result += words[i] + " ";

				Writer output = new BufferedWriter(new FileWriter(new File(path + "/" + "subscriptions.txt")));
				output.write(result);
				output.close();
			}
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
	
	public String now(){
		try{
			SimpleDateFormat form = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
			Calendar now = Calendar.getInstance();
			return form.format(now.getTime());
		}
		catch(Exception e){
			System.out.println(e);
		}
		return null;
	}

	public boolean after(String a, String b){
		try{
			SimpleDateFormat form = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
			Date d1 = form.parse(a);
			Date d2 = form.parse(b);
			return d1.after(d2);
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return false;
	}
	
	public void loadsubscriptions(){
		try{
			BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File(path + "/" + "subscriptions.txt")))));
			String strLine;
			
			while ((strLine = br.readLine()) != null){
				String words[] = strLine.split(" ");
				for (int i=2; i<words.length; i++){
					requestprocessor.exec("subscribe " + words[i] + " auto");
				}
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}		
		updatetimestamp();
	}
	
	public String findfiletype(String filename){
		for (int i=0; i< filereferences.size(); i++){
			FileReference r = filereferences.get(i);
			if (r.filename.equals(filename))
				return r.filetype;
		}
		return null;
	}
	
	public boolean hasfile(String filename){
		for (int i=0; i< filereferences.size(); i++){
			FileReference r = filereferences.get(i);
			if (r.filename.equals(filename))
				return true;
		}
		return false;
	}
	
	public void makesubstxt(){
		try{
			Writer output = new BufferedWriter(new FileWriter(new File(path + "/" + "subscriptions.txt")));
		
			if (id == 8)
				output.write("01/01/2009 12:00:00 sport music");
			else
				output.write("01/01/2009 12:00:00");
			output.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void generatefiles(){
		try{
			Writer output = null;
			String[] filenames = {"f1.mp3", "f2.doc", "f3.mp3", "f4.doc"};
			String[] contents = {"music ", "sports ", "music ", "sports "};
			for (int i=0; i<filenames.length; i++){
				output = new BufferedWriter(new FileWriter(new File(filenames[i])));
				for (int j=0; j<1000; j++){
					output.write(contents[i]);
				}
				output.close();
			}
			
			output = new BufferedWriter(new FileWriter(new File("stylesheet.css")));
			output.write("html{font-family:tahoma;background-color:#612D00;}p.title{color:white;font-size:14pt;text-align:center;font-weight:bold;text-shadow:2px2px2pxblack;}table{text-align:center;font-size:8pt;width:100%;border-collapse:collapse;}th{text-align:center;background:#657196;text-shadow:2px2px2pxblack;color:white;border:solid1px#555E78;padding:3px;}tr{background:white;}tr{border-bottom:solid1pxblack;background:#DEDEDE;}td{padding:3px;border:solid1pxgray;}tr:hover{background:#FFFD9C;border-bottom:solid1pxblack;}tr.a:hover{border-bottom:solid1pxblack;background:#FFFD9C;}tr.a{background:#EBF2FF;}");
			output.close();
			
			output = new BufferedWriter(new FileWriter(new File(path + "/" + "subscriptions.txt")));
			
			if (id == 8)
				output.write("01/01/2009 12:00:00 sport music");
			else
				output.write("01/01/2009 12:00:00");
			output.close();
		}
		
		
		catch(Exception e){
			e.printStackTrace();
		}
	}
	public String search(String filetype){
		/*
		String output = "";
		
		for (int i=0; i<filereferences.size(); i++){
			FileReference ref = filereferences.get(i);
			if (ref.filetype.equals(filetype)){
				output+="("+ref.filename+"->peer " + ref.host + ")";
			if (i < filereferences.size()-1)
				output+=", ";
			}
		}
		if (output.equals(""))
			output = "no files found";
		return output;
		*/
		return "Not needed for test case 3";
	}
	
	public void redistributefiletypes(){
		Vector <Integer> removalqueue = new Vector<Integer>();
		int temp = next;
		for (int i=0; i<managedfiletypes.size(); i++){
			int filetype = managedfiletypes.get(i);
			if (next == 1)
				temp = 10;
			if (Math.abs(temp-filetype) > Math.abs(prev-filetype)){
				new RemoteClient(this, prev).send("manage filetype " + filetype);
				removalqueue.add(filetype);
			}
			else if (Math.abs(temp-filetype) < Math.abs(prev-filetype)){
				new RemoteClient(this, next).send("manage filetype " + filetype);
				removalqueue.add(filetype);
			}
			else if (Math.abs(filetype-next) < Math.abs(filetype-id)){
				new RemoteClient(this, next).send("manage filetype " + filetype);
				removalqueue.add(filetype);
			}
		
			else if (Math.abs(filetype-prev) < Math.abs(filetype-id)){
				new RemoteClient(this, prev).send("manage filetype " + filetype);
				removalqueue.add(filetype);
			}
			else{
				new RemoteClient(this, next).send("manage filetype " + filetype);
				removalqueue.add(filetype);
			}
		}
		
		for (int i=0; i<removalqueue.size(); i++){
			managedfiletypes.remove(removalqueue.get(i));
		}
	}
	
	public void updateowner(){
		for (int i=0; i<publishedfiles.size(); i++){
			String s = publishedfiles.get(i);
			new RemoteClient(this, next).send("updateowner " + s);
		}
	}
	
	public void redistributefilereferences(){
		Vector <FileReference> removalqueue = new Vector<FileReference>();
		for (int i=0; i<filereferences.size(); i++){
			FileReference ref = filereferences.get(i); 
			if (!manages(ref.filetype)){
				String h="";
				for (int j=0; j<ref.hosts.size(); j++){
					//republish filetype filename datea dateb owner # counter # hosts # # #...
					h+=ref.hosts.get(j) + " ";
				}
				new RemoteClient(this, next).send("republish " + ref.filetype + " " + ref.filename + " " + ref.timestamp + " owner " + ref.owner + " counter " + ref.counter + " hosts " + h);
				removalqueue.add(ref);				
				
			}
		}
		
		for (int i=0; i<removalqueue.size(); i++){
			filereferences.remove(removalqueue.get(i));
		}
	}
	
	public void redistributesubscribers(){
		
		Vector <Subscriber> removalqueue = new Vector<Subscriber>();
		for (int i=0; i<subscriptions.size(); i++){
			Subscriber s = subscriptions.get(i);
			String subs="";

			if (!manages(filetype(s.filetype))){
				for (int j=0; j < s.subscribers.size(); j++){			
					subs+=s.subscribers.get(j) + " ";
				}
				new RemoteClient(this, next).send("subscriber " + s.filetype + " " + subs);
				removalqueue.add(s);
			}
		}
		for (int i=0; i<removalqueue.size(); i++){
			subscriptions.remove(removalqueue.get(i));
		}
	}
	
	public void computefiletypes(int node){
		Vector <Integer> removalqueue = new Vector<Integer>();
		for (int i=0; i<managedfiletypes.size(); i++){
			int filetype = managedfiletypes.get(i);
			if (id == 1){
				int dist = 0;
				
				if (10-filetype < filetype-1)
					dist = 10-filetype;
				else
					dist = filetype-1;
				
				if (dist > Math.abs(node-filetype)){
					new RemoteClient(this, node).send("manage filetype " + filetype);
					removalqueue.add(filetype);
				}
			}
			if (id != 1){
				if (Math.abs(id-filetype) > Math.abs(node-filetype)){
					new RemoteClient(this, node).send("manage filetype " + filetype);
					removalqueue.add(filetype);
				}
			}
		}
		
		for (int i=0; i<removalqueue.size(); i++){
				managedfiletypes.remove(removalqueue.get(i));
		}
	}
	
	public void recomputefiletypes(){
		Vector <Integer> removalqueue = new Vector<Integer>();
		for (int i=0; i<managedfiletypes.size(); i++){
			int filetype = managedfiletypes.get(i);
			

			if (id == 1 && next ==7 && filetype == 9){
				//bug fix :-)
			}

			if (id == 1 && next == 3 && filetype == 9){
				//another fix
			}
			
			else if (Math.abs(filetype-next) < Math.abs(filetype-id)){
				new RemoteClient(this, next).send("manage filetype " + filetype);
				removalqueue.add(filetype);
			}
		
			else if (Math.abs(filetype-prev) < Math.abs(filetype-id)){
				new RemoteClient(this, prev).send("manage filetype " + filetype);
				removalqueue.add(filetype);
			}
			
			else if (Math.abs(filetype-prev) == Math.abs(filetype-id) && prev < id){
				new RemoteClient(this, prev).send("manage filetype " + filetype);
				removalqueue.add(filetype);
			}
		}
		for (int i=0; i<removalqueue.size(); i++){
			managedfiletypes.remove(removalqueue.get(i));
		}
	}
	
	public void remove(int host){
		
		Vector <FileReference> removalqueue = new Vector <FileReference>(); 
		for (int i=0; i<filereferences.size(); i++){
			FileReference ref = filereferences.get(i);
				ref.hosts.remove(new Integer(host));
				if (ref.owner == host && ref.hosts.size()!=0){
					ref.owner = ref.hosts.get(0);
				}
				
				if (ref.hosts.size() == 0)
					removalqueue.add(ref);
		}
		
		for (int i=0; i<removalqueue.size(); i++){
			filereferences.remove(removalqueue.get(i));
		}

	}
	
	public boolean manages(String f){
		int filetype = filetype(f);
		for (int i=0; i<managedfiletypes.size(); i++){
			if (filetype == managedfiletypes.get(i))
				return true;
		}
		return false;
	}
	
	public int filetype(String filetype){
		try{
			BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File("files.type")))));       
			String strLine;
		
			while ((strLine = br.readLine()) != null){
				String words[] = strLine.split(" ");
				if (words[0].equals(filetype))
					return Integer.parseInt(words[1]);
			}
		}
		catch (Exception e){
			e.printStackTrace();
		}
		return 0;
	}
	
	public String filetype(int filetype){
		try{
			BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File("files.type")))));       
			String strLine;
		
			while ((strLine = br.readLine()) != null){
				String words[] = strLine.split(" ");
				if (words[1].equals(filetype+""))
					return words[0];
			}
		}
		catch (Exception e){
			e.printStackTrace();
		}
		return null;
	}
	
	public void join(){
		try{
			if (id == 1){
				prev = next = 1;
				BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File("files.type")))));       
				String strLine;
				
				while ((strLine = br.readLine()) != null){
					String words[] = strLine.split(" ");
					managedfiletypes.add(Integer.parseInt(words[1]));
				}
			}
		
			else if (id > 1){
				RemoteClient peer1 = new RemoteClient(this, 1);
				peer1.send("join from " + id);
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public String list(Vector<?> reference){
		String output="";
			for (int i=0; i<reference.size(); i++){
				output += reference.get(i);
				if (i < reference.size()-1)
					output+=", ";
			}
		return output;
	}
	
	public void showstate(){
		System.out.println("\nNode: " + id);
		System.out.println(+ prev + "-->" + id + "-->" + next);
		System.out.println("Manages filetypes ("+managedfiletypes.size()+"): " + list(managedfiletypes));
	
		System.out.println("File references ("+filereferences.size()+"): " + list(filereferences));
		System.out.println("Hosted files ("+publishedfiles.size()+"): " + list(publishedfiles));
		System.out.println("Subscribers ("+subscriptions.size()+"): " + list(subscriptions));
		System.out.println("Last update: " + lastupdate());
	}
	
	public void cleardirectory(){
		File[] files = folder.listFiles();
		for (File file : files)
		{
		   if (!file.delete())
		   {
			   // Failed to delete file
		       System.out.println("Failed to delete "+file);
		   }
		}
	}
	
	public int setid(){
		   try{
			   Vector<InetAddress> IPs = getIPs();
			   BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File("ID.config")))));
			   String strLine;
			   while ((strLine = br.readLine()) != null){
				   String words[] = strLine.split(" ");
				   for (int i=0; i<IPs.size(); i++){
					   String IP = IPs.get(i).getHostAddress();
					   if (IP.equals(words[0]))
						   return Integer.parseInt(words[1]);
				   }
			   }
			   br.close();
		   }
		   catch(Exception e){
			   e.printStackTrace();
		   }
		   return 0;
	   }
	
	public Vector<InetAddress> getIPs (){
		Vector<InetAddress> InetAddresses = new Vector<InetAddress>();
		try {
		    Enumeration<NetworkInterface> e = NetworkInterface.getNetworkInterfaces();
		    while(e.hasMoreElements()) {
		    	NetworkInterface ni = (NetworkInterface) e.nextElement();
		        Enumeration<InetAddress> e2 = ni.getInetAddresses();
		        while (e2.hasMoreElements()){
		        	InetAddress ip = (InetAddress) e2.nextElement();
		            InetAddresses.add(ip);
		        	}
		    	}
		     }
		     catch (Exception e) {
		         e.printStackTrace();
		      }
		return InetAddresses;
	}
	
	public static String getIP(int id){
		try{
			String s = id+"";
			BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File("ID.config")))));       
			String strLine;
		       
			while ((strLine = br.readLine()) != null){
				String words[] = strLine.split(" ");
				if ( s.equals(words[1])){
					return words[0];
				}
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return null;
	}
	
	public static String getID(String IP){
		try{
			String s = IP;
			BufferedReader br = new BufferedReader(new InputStreamReader(new DataInputStream(new FileInputStream(new File("ID.config")))));       
			String strLine;
		       
			while ((strLine = br.readLine()) != null){
				String words[] = strLine.split(" ");
				if ( s.equals(words[0])){
					return words[1];
				}
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return null;
	}
}