import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.Socket;

public class RemoteClient extends Thread{
	Peer peer;
	Socket sock;
	BufferedReader serverOutput;
	DataOutputStream clientInput;
	String address;
	
	RemoteClient(Peer peer, String address, int port){
		super("Remote Client");
		try{
			this.peer = peer;
			this.address = address;
			
			while(sock == null){
			try{
				sock = new Socket(address, port);
				}
				catch(Exception e){
				}
			}
			peer.logger.log(this, "Connected: " + sock);
			serverOutput = new BufferedReader(new InputStreamReader(sock.getInputStream()));
			clientInput = new DataOutputStream(sock.getOutputStream());
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	RemoteClient(Peer peer, int peerid){
		this(peer, Peer.getIP(peerid), peer.port);
	}
	
	RemoteClient(Peer peer, int peerid, int port){
		this(peer, Peer.getIP(peerid), port);
	}
	
	RemoteClient(Peer peer, String address){
		this(peer, address, 6789);
	}
	
	public void send(String request){
		try{
			while(sock==null){
				;
			}
			clientInput.writeBytes(request+'\n');
			peer.logger.log(this, "Sent " + sock.getRemoteSocketAddress() + " Request: "+request);
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
	
	public String receive(){
		try{
			String reply = serverOutput.readLine(); 
			peer.logger.log(this, "Received reply: " + reply);
			return reply;
			
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return null;
	}
	
	public void sendfile(String filename){
		try{
			File f = new File (filename);
			send("Open a port to receive " + filename);
			String fileport = receive();
			Socket filesock = null;
			
			while(filesock == null){
				try{
					filesock = new Socket(address, Integer.parseInt(fileport));
					}
					catch(Exception e){
					}
				}
									
		    byte [] mybytearray  = new byte [(int)f.length()];
		    FileInputStream fis = new FileInputStream(f);
		    BufferedInputStream bis = new BufferedInputStream(fis);
		    bis.read(mybytearray,0,mybytearray.length);
		    OutputStream os = filesock.getOutputStream();
		    os.write(mybytearray,0,mybytearray.length);
		    os.flush();
		    filesock.close();
		    
		    count(filename);
		    
		    peer.logger.println(this, "File: '"+f.getName()+"' Received, Size=" + f.length() + " bytes");
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void count(String filename){
		for (int i=0; i<peer.filereferences.size(); i++){
			FileReference r = peer.filereferences.get(i);
			if (r.filename.equals(filename))
				r.counter++;
		}
	}
	
	public void getfile(String filename){
		try{
			send("Open a port to send " + filename);
			String fileport = receive();
			System.out.println("Received Port: " + fileport);
			Socket filesock = null;
			
			while(filesock == null){
				try{
					filesock = new Socket(address, Integer.parseInt(fileport));
					}
					catch(Exception e){
					}
				}
			
			int filesize=6022386, bytesRead, current = 0;
			byte [] mybytearray  = new byte [filesize];
			InputStream is = filesock.getInputStream();
			FileOutputStream fos = new FileOutputStream(peer.path + "/" + filename);
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			bytesRead = is.read(mybytearray,0,mybytearray.length);
			current = bytesRead;

		    do {
				bytesRead = is.read(mybytearray, current, (mybytearray.length-current));
				if (bytesRead >= 0) current += bytesRead;
				} while(bytesRead > -1);

			bos.write(mybytearray, 0 , current);
			bos.flush();
			File f = new File(peer.path + "/" + filename);
			
			if (f.exists()){
				peer.logger.println(this, "File: '"+f.getName()+"' Received, Size=" + f.length() + " bytes");
			}
			bos.close();
			filesock.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}	
}
