import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Random;

public class ServerThread extends Thread{

	Socket sock;
	DataOutputStream out;
	BufferedReader in;
	String clientInput;
	Peer peer;
	
	ServerThread(Peer p, Socket sock) throws IOException{
		super("Server Thread");
		this.peer = p;
		this.sock = sock;
		this.in = new BufferedReader(new InputStreamReader(sock.getInputStream()));
		this.out = new DataOutputStream(sock.getOutputStream());
		start();
	}
	
	public void run(){
		try{
			while(sock.isConnected()){
				clientInput = in.readLine();
				if(clientInput!=null){
					peer.requestprocessor.exec(clientInput);
					//out.writeBytes("Received: " + clientInput);
				
					String reqword[] = clientInput.split(" ");
					
					//Open a port to receive/send filename
					if (reqword[0].equals("Open")){
						int fileport = getfreeport(3000, 65535);
						out.writeBytes(fileport + "\n");
						new FileServer(peer, fileport, reqword[4], reqword[5]);
					}
				}
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public int getfreeport(int start, int end){
		Random randomGenerator = new Random();
	    long range = (long)end - (long)start + 1;
		long fraction = (long)(range * randomGenerator.nextDouble());
		int port = (int)(fraction + start);
		
		try {
			ServerSocket servsock = new ServerSocket(port);
			servsock.close();
			return port;
		} 
		catch (Exception e) {
			return getfreeport(start, end);
		}
	}
}
